/*
 * Copyright 2000 by Hans Reiser, licensing governed by reiserfs/README
 */

/* nothing abount reiserfs here */

void die (char * fmt, ...);
void * getmem (__u32 size);
void freemem (void * p);
void * expandmem (void * p, int size, __u32 by);
int is_mounted (char * device_name);
void check_and_free_mem (void);
char * kdevname (int dev);


int set_bit (int nr, void * addr);
int clear_bit (int nr, void * addr);
int test_bit(int nr, const void * addr);
int find_first_zero_bit (const void *vaddr, unsigned size);
int find_next_zero_bit (const void *vaddr, unsigned size, unsigned offset);

void print_how_far (__u32 * passed, __u32 total);



/*
int test_and_set_bit (int nr, void * addr);
int test_and_clear_bit (int nr, void * addr);
*/
inline __u32 cpu_to_le32 (__u32 val);
inline __u32 le32_to_cpu (__u32 val);
inline __u16 cpu_to_le16 (__u16 val);
inline __u16 le16_to_cpu (__u16 val);
inline __u64 cpu_to_le64 (__u64 val);
inline __u64 le64_to_cpu (__u64 val);

unsigned long count_blocks (char * filename, int blocksize, int fd);



#define test_bitmap_bit(bitmap,block,blocksize) \
test_bit ((block) % ((blocksize) * 8), bitmap[(block) / ((blocksize) * 8)])

#define set_bitmap_bit(bitmap,block,blocksize) \
set_bit ((block) % ((blocksize) * 8), bitmap[(block) / ((blocksize) * 8)])

#define clear_bitmap_bit(bitmap,block,blocksize) \
clear_bit ((block) % ((blocksize) * 8), bitmap[(block) / ((blocksize) * 8)])
